Loading...
Searching...
No Matches
L4Re::Mem_alloc::Stats Struct Reference

Statistics about memory-allocator. More...

`#include <mem_alloc>`

Collaboration diagram for L4Re::Mem_alloc::Stats:

## Data Fields

l4_size_t | quota
| Memory quota of this allocator.
l4_size_t | quota_used
| Amount of currently used quota of this allocator.
l4_size_t | mem_limit
| Maximum amount of memory that can be allocated by this allocator.
l4_size_t | mem_used
| Amount of currently allocated memory.
l4_size_t | mem_free
| Amount of memory that is still available for allocation.

## Detailed Description

Statistics about memory-allocator.

Definition at line 74 of file mem_alloc.

## Field Documentation

## mem_free

l4_size_t L4Re::Mem_alloc::Stats::mem_free

Amount of memory that is still available for allocation.

This field can be lower than mem_limit - mem_used. In this case the system may be over-committed and there is globally not enough memory left. Also, if the quota is already used up for sub-factories (see quota_used), there may be not enough quota left.

Definition at line 126 of file mem_alloc.

## mem_limit

l4_size_t L4Re::Mem_alloc::Stats::mem_limit

Maximum amount of memory that can be allocated by this allocator.

Will never exceed the quota but may be smaller if the system has less memory installed.

Definition at line 102 of file mem_alloc.

## mem_used

l4_size_t L4Re::Mem_alloc::Stats::mem_used

Amount of currently allocated memory.

This field represents the amount of memory that is in use by this allocator. It recursively includes the memory used by sub-factories, if any.

Will never exceed mem_limit or quota_used.

Note
  Dataspaces may allocate memory lazily! As such, the field will increase only after pages have been allocated to a dataspace.

Definition at line 116 of file mem_alloc.

## quota

l4_size_t L4Re::Mem_alloc::Stats::quota

Memory quota of this allocator.

Strictly limits the amount of memory that can be allocated. This may be larger than there is actual physical memory available. In particular, the root factory has an artificial quota and returns -1 in this field.

Definition at line 83 of file mem_alloc.

## quota_used

l4_size_t L4Re::Mem_alloc::Stats::quota_used

Amount of currently used quota of this allocator.

The amount of used quota is not necessarily linked to the current memory usage. See mem_used for this information. The quota of a factory is immediately and fully accounted to the parent factory quota.

This value may even exceed mem_limit if the system is over-committed.

Definition at line 94 of file mem_alloc.

The documentation for this struct was generated from the following file:

- l4/re/mem_alloc